﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using HeuristicLab.MainForm;
using HeuristicLab.Core.Views;
using HeuristicLab.Core;
using HeuristicLab.Data;

namespace HeuristicLab.Problems.MetaOptimization.Views {
  /// <summary>
  /// The visual representation of a <see cref="IIntegerRange"/>.
  /// </summary>
  [View("NumericRange View")]
  [Content(typeof(IRange<IntValue>), true)]
  public partial class IntValueRangeView : ItemView {
    /// <summary>
    /// Gets or sets the variable to represent visually.
    /// </summary>
    /// <remarks>Uses property <see cref="ViewBase.Item"/> of base class <see cref="ViewBase"/>.
    /// No own data storage present.</remarks>
    public new IRange<IntValue> Content {
      get { return (IRange<IntValue>)base.Content; }
      set { base.Content = value; }
    }

    public IntValueRangeView() {
      InitializeComponent();
    }

    protected override void RegisterContentEvents() {
      base.RegisterContentEvents();
    }

    protected override void DeregisterContentEvents() {
      base.DeregisterContentEvents();
    }

    protected override void OnContentChanged() {
      base.OnContentChanged();
      if (Content != null) {
        lowerValueView.Content = Content.LowerBound;
        upperValueView.Content = Content.UpperBound;
        stepSizeValueView.Content = Content.StepSize;
      } else {
        lowerValueView.Content = null;
        upperValueView.Content = null;
        stepSizeValueView.Content = null;
      }
    }

    protected override void SetEnabledStateOfControls() {
      base.SetEnabledStateOfControls();
    }
  }
}
